//
//    MARAUDER
//
//    alien.h: cool stuff here, lots of nifty collision checks.
//
//    By Shawn Hargreaves, 1995.
//
//    C++ source code for djgpp, using the 
//    Allegro game programming library.



multidir *draw_alien(int *rcol, void (*callback)(void));


class alien : public spaceship
{
    friend class alienmgr;
public:
    alien(genepool *g);
    virtual int move();
    virtual void collide(item *other);
protected:
    multidir *spr;
    int money;
    int cargo;
    int speed_shift;
    int turn_speed;
    int shields;
    geneinstance *mygene;
    genepool *genes;
    info inf;
    int shootdelay;
    void play_my_sample(struct SAMPLE *spl, int freq);
};



class alienmgr : public spritemgr
{
public:
    void move(int x);
    void check_ship_collision(playership *ship);
protected:
    void check_items(item *i1, item *i2);
    int get_dist(item *i1, item *i2);
    int get_dir(item *i1, alien *i2);
    void bullet_collision_check();
    void planet_collision_check();
    void treasure_collision_check();
    void alien_collision_check();
};

