//
//    MARAUDER
//
//    bullet.h: for shooting people
//
//    By Shawn Hargreaves, 1995.
//
//    C++ source code for djgpp, using the 
//    Allegro game programming library.



enum {
    WEAPON_LASER = 0,
    WEAPON_PROTON_GUN,
    WEAPON_MATTER_CANNON,
    WEAPON_MISSILE,
    WEAPON_TORPEDO,
    WEAPON_MINE
};



class bullet : public item
{
public:
    bullet(item *p, multidir *m, int d);
    virtual ~bullet() { ; }
    virtual int move() { x+=xc; y+=yc; return (--life>0) ? 0 : -1; }
    void kill() { life = 0; }
    item *get_parent() { return parent; }
    int get_harm() { return harm; }
    int is_missile;
protected:
    int harm;
    int dir;
    int life;
    item *parent;
    multidir *mdir;
};



class laser : public bullet
{
public:
    laser(int d, int x, int y, item *p);
};



class proton_gun : public bullet
{
public:
    proton_gun(int d, int x, int y, item *p);
};



class matter_cannon : public bullet
{
public:
    matter_cannon(int d, int x, int y, item *p);
};



class missile : public bullet
{
public:
    missile(int d, int x, int y, item *p);
    virtual int move();
protected:
    int dev;
    int dev_speed;
    int dev_count;
};



class torpedo : public bullet
{
public:
    torpedo(int d, int x, int y, item *p);
    virtual int move();
protected:
    int xcadd, ycadd;
};



class mine : public bullet
{
public:
    mine(int d, int x, int y);
    virtual int move() { current_sprite=mdir->sprite(dir--); return (life>0) ? 0 : -1; }
};



